/*
 * $Id$
 * This is an unpublished work copyright (c) 2003 Jens-Uwe Mager
 * 30177 Hannover, Germany, jum@anubis.han.de
 */

import java.io.*;
import java.net.*;
import java.security.*;
import com.bitzi.util.Base32;
import com.limegroup.gnutella.security.SHA1;

class BuildMagnet {
    public static void main(String args[]) throws Throwable {
        if (args.length < 1 || args.length > 2) {
            System.err.println("Usage: java BuildMagnet file_path [base_url]");
            System.exit(1);
        }
        File file = new File(args[0]);
        FileInputStream fis = new FileInputStream(file);
        //MessageDigest md = MessageDigest.getInstance("SHA");
        MessageDigest md = new SHA1();
        byte[] buffer = new byte[16384];
        int read;
        while ((read = fis.read(buffer)) != -1)
            md.update(buffer, 0, read);
        fis.close();
        byte[] sha1 = md.digest();
        String urn = "urn:sha1:" + Base32.encode(sha1);
        if (args.length > 1)
            System.out.println("magnet:?xt=" + urn + "&dn=" +
                URLEncoder.encode(file.getName(), "UTF-8") + "&xs=" + args[1] +
                "/uri-res/N2R?" + urn);
        else
            System.out.println("magnet:?xt=" + urn + "&dn=" +
                URLEncoder.encode(file.getName(), "UTF-8"));
    }
}
